*
*	Pic.s -- pic$@%U%)!<%^%C%H2hA|$r07$&(J
*
*		created    in 3/1/1993
*		revised    in 2/13/1994
*
*	X68000 assembler version 4/29/1999 Rick

* NO_APP
RUNS_HUMAN_VERSION	equ	3
	.cpu 68000
	.include doscall.equ
* X68 GCC Develop


PicBitWrite	macro

	local	lp0,lp1,lp1_e,lp0_e,lp2,lp2_e

	bra	lp0_e
lp0
	sub.w	d7,d2		*Rest--
	movea.l	BITBUFFERPOINTER(a5),a0
	move.w	(a0),d0
	bra	lp1_e
lp1
	add.w	d0,d0
	add.l	d3,d3		*Cache*= 2
	bcc	lp1_e
	addq.w	#1,d0
lp1_e
	dbra	d7,lp1
	move.w	d0,(a0)
	bsr	PicWriteBufferNext
lp0_e
	cmp.w	d7,d2
	bgt	lp0

	sub.w	d2,d7
	move.l	BITBUFFERPOINTER(a5),a0
	move.w	(a0),d0
	bra	lp2_e
lp2
	add.w	d0,d0
	add.l	d3,d3
	bcc	lp2_e
	addq.w	#1,d0
lp2_e
	dbra	d2,lp2
	move.w	d0,(a0)

	endm


PicBitWrite1ON	macro

	local	storeON

	dbra	d7,storeON
	bsr	PicWriteBufferNext
	subq.w	#1,d7
storeON
	move.l	BITBUFFERPOINTER(a5),a0
	move.w	(a0),d0
	add.w	d0,d0
	addq.w	#1,d0
	move.w	d0,(a0)

	endm


PicBitWrite1OFF	macro

	local	storeOFF

	dbra	d7,storeOFF
	bsr	PicWriteBufferNext
	subq.w	#1,d7
storeOFF
	move.l	BITBUFFERPOINTER(a5),a0
	move.w	(a0),d0
	add.w	d0,(a0)

	endm

	.offset -10

FILEHANDLE		.ds.w	1
BITBUFFER		.ds.l	1
BITBUFFERLENGTH		.ds.l	1
BITBUFFERPOINTER	.ds.l	1
COLORMAP		.ds.l	1
COLORPOINTER		.ds.w	1
LRUCACHE		.ds.b	512

	.even
	.text
?C0:
	.dc.b '%s: %s: No such file',$0a,$00
?C1:
	.dc.b '%s: %s: Insufficient memory',$0a,$00
?C2:
	.dc.b '%s: %s: Is not pic format',$0a,$00
?C3:
	.dc.b '%s: %s: load error',$0a,$00
	.even
	.globl _PicLoad
_PicLoad:
	link	a6,#-1348
	movem.l	d4/a3,-(sp)
	lea.l	-1348(a6),a3
	tst.l	_fp
	beq	@f
	moveq.l	#0,d1
	move.l	d1,(a3)
	bra	initial_load
@@
	clr.w	-(sp)
	move.l	_File,-(sp)
	DOS	_di_open
	addq.w	#6,sp
	move.l	d0,(a3)
	bge	initial_load
	lea	?C0(OPC),a0
	bra	errput
initial_load:
	move.l	a3,-(sp)
	jsr	_loadPICfile
	addq.w	#4,sp
	cmp.l	#200,d0
	beq	load_open
	cmp.l	#205,d0
	bne	@f
	lea.l	?C1(OPC),a0
	bra	errput
@@
	lea.l	?C2(OPC),a0
	bra	errput
load_open:
	move.l	20(a3),d4
	move.l	d4,_Width
	move.l	24(a3),d1
	move.l	d1,_Height
	move.l	_Screen,d0
	beq	@f
	move.l	d0,-(sp)
	DOS	_di_mfree
	addq.w	#4,sp
@@
	move.l	d4,d0
	tst.l	_NoExpand
	bne	@f
	move.l	d4,d2
	add.l	d2,d2
	add.l	d2,d2
	divu	#3,d2
	moveq.l	#0,d0
	move.w	d2,d0
	move.l	d0,_Width
@@
	add.l	d1,d1
	mulu	d1,d0
	move.l	d0,_Size
	move.l	d0,-(sp)
	DOS	_di_malloc
	addq.w	#4,sp
	move.l	d0,_Screen
	bge	@f
	move.l	a3,-(sp)
	jsr	_EndOfDraw
	lea.l	?C1(OPC),a0
	bra	errput
@@
	move.l	d0,38(a3)
	move.l	a3,-(sp)
	jsr	_drawPIC
	addq.w	#4,sp
	cmp.l	#201,d0
	beq	@f
	lea.l	?C3(OPC),a0
	bra	errput
@@
	tst.l	_NoExpand
	bne	@f
	move.l	d4,-(sp)		*Width
	jsr	_Transform_ft
	addq.w	#4,sp
@@
	move.l	#32768,_MaxColorGuaranteed
	movem.l	(sp)+,d4/a3
	unlk	a6
	rts

	.even
_ColorCachInitialize:
	move.l	COLORMAP(a5),a0
	movea.l	a0,a1
	moveq.l	#-1,d0
	move.l	#32768/4-1,d1
@@
	move.l	d0,(a0)+
	dbra	d1,@b

	clr.b	(a1)

	moveq.l	#128-1,d1
	moveq.l	#0,d0
	lea.l	LRUCACHE(a5),a0
	lea.l	256(a0),a1	*prev
	lea.l	128(a1),a2	*next
@@
	clr.w	(a0)+
	subq.b	#1,d0
	move.b	d0,(a2)+
	addq.b	#2,d0
	move.b	d0,(a1)+
	dbra	d1,@b

	move.b	#127,(a1)
	clr.b	-(a1)
	clr.w	COLORPOINTER(a5)
	rts

?C5:
	.dc.b '%s: %s: Cannot create',$0a,$00

	.even
	.globl _PicSave
_PicSave:
	movem.l	d3/d4/d5/d6/d7/a3/a4/a5/a6,-(sp)
	lea.l	BitBuf+10,a5
	tst.l	_fp
	bne	out_stdout
	moveq.l	#$20,d0
	move.w	d0,-(sp)
	move.l	_File,-(sp)
	DOS	_di_create
	addq.w	#6,sp
	tst.w	d0
	bpl	openok
	clr.w	FILEHANDLE(a5)
	lea.l	?C5(OPC),a0
	bra	errput
out_stdout:
	moveq.l	#1,d0
openok:
	move.w	d0,FILEHANDLE(a5)
	move.l	#65536,-(sp)
	DOS	_di_malloc
	addq.w	#4,sp
	move.l	d0,BITBUFFER(a5)
	bge	@f
	lea.l	?C1(OPC),a0
	bra	errput
@@
	move.l	d0,BITBUFFERPOINTER(a5)
	add.l	#32768,d0
	move.l	d0,COLORMAP(a5)
	move.l	#32768,BITBUFFERLENGTH(a5)
	moveq.l	#16,d7
	bsr	_ColorCachInitialize
	lea.l	_Width,a3
	move.l	(a3),d6
	tst.l	_NoExpand
	bne	@f
	jsr	_Transform_tf
	move.l	d6,d1
	add.l	d1,d1
	add.l	d1,d6
	lsr.l	#2,d6
	move.l	d6,(a3)
@@
	bsr	WritePicHeader

*DifferentPointMark
	movea.l	_Screen,a6
	movea.l	a6,a0
	move.l	d6,d1
	move.l	_Height,d0
	mulu	d1,d0
	moveq.l	#0,d2		*c
	bra	d_lp_ent
d_lp:
	move.w	(a0)+,d1	*a
	cmp.w	d1,d2
	beq	d_lp_ent
	move.w	d1,d2
	tas	-2(a0)
d_lp_ent:
	dbra	d0,d_lp
	clr.w	d0
	subq.l	#1,d0
	bpl	d_lp

*CompressPic
	moveq.l	#0,d5		*y
	movea.l	d5,a3		*Length
	bra	c_ylp_ent
c_ylp:
	moveq.l	#0,d4		*x
	bra	c_xlp_ent
c_xlp:
	addq.w	#1,a3		*Length
	move.w	(a6)+,d1
	bge	notmark
	movem.l	d4/d5/d6/a6,-(sp)
	lea.l	-2(a6),a4
	move.w	d1,a6		*c | 0x8000
	andi.w	#$7fff,(a4)	*ResetMark
	bsr	WriteLength
*WriteColor
	moveq.l	#0,d3
	move.w	a6,d3
	andi.w	#$7fff,d3	*c
	move.l	d3,d0

*SearchColor:
	move.l	COLORMAP(a5),a3
	lea.l	COLORPOINTER(a5),a0
	move.w	(a0),d1		*cp
	moveq.l	#0,d2
	move.b	(a3,d0.w),d2
	bge	SetColor

*NewColor
	move.w	d1,d2
	add.w	d2,d2
	movea.l	a3,a2
	lea.l	LRUCACHE(a5),a1
	add.w	(a1,d2.w),a2	*map[color[cp]]
	st	(a2)		*color map clear
	clr.w	d2
	lea.l	256(a1),a2	*prev
	move.b	(a2,d1.w),d2	*p[cp]
	move.w	d2,(a0)		*cp= p[cp]
	move.b	d2,(a3,d0.w)	*map[c]= cp
	add.w	d2,d2
	move.w	d0,(a1,d2.w)	*color[cp]= c

	PicBitWrite1OFF

	moveq.l	#15,d2
	add.w	d3,d3
	swap	d3
	PicBitWrite

	bra	CompressChain

SetColor:
	cmp.b	d1,d2
	beq	same

	move.w	d2,(a0)		*c= i
	lea.l	LRUCACHE+384(a5),a0	*next

	lea.l	(a0,d2.w),a2	*n[i]
	clr.w	d0
	move.b	(a2),d0		*n[i]
	move.b	d1,(a2)		*n[i]= c
	lea.l	-128(a0,d1.w),a2	*p[c]
	lea.l	-128(a0,d2.w),a1	*p[i]
	move.b	(a1),d1		*p[i]
	move.b	d0,(a0,d1.w)	*n[p[i]]= n[i]
	move.b	d1,-128(a0,d0.w)	*p[n[i]]= p[i]
	move.b	(a2),d0		*p[c]
	move.b	d2,(a0,d0.w)	*n[p[c]]= i
	move.b	d0,(a1)		*p[i]= p[c]
	move.b	d2,(a2)		*p[c]= i
same:
	move.l	d2,d3
	moveq.l	#8,d2
	tas	d3
	lsl.w	#8,d3
	swap	d3
	PicBitWrite

CompressChain:
	movea.l	d6,a3		*Width
	moveq.l	#0,d3		*f
	addq.w	#1,d5		*yy
	bra	cc_ylp_ent
cc_ylp:
	adda.l	a3,a4
	adda.l	a3,a4
	move.w	(a4),d0		* *p
	cmp.w	a6,d0		*a
	bne	left1
	moveq.l	#2,d6
	bra	chain
left1:
	dbra	d4,@f
right1:
	addq.w	#2,d4
	cmp.w	a3,d4
*	bgt	left2
	bge	left2
	move.w	2(a4),d0
	cmp.w	a6,d0
	bne	left2
	moveq.l	#3,d6
	addq.w	#2,a4
	bra	chain
@@
	move.w	-2(a4),d0
	cmp.w	a6,d0
	bne	right1
	moveq.l	#1,d6
	subq.w	#2,a4
	bra	chain
left2:
	subq.w	#3,d4
	bmi	right2
	move.w	-4(a4),d0
	cmp.w	a6,d0
	bne	right2
	moveq.l	#4,d6
	subq.w	#4,a4
	bra	chain
right2:
	addq.w	#4,d4
	cmp.w	a3,d4
*	bgt	chain_end
	bge	chain_end
	addq.w	#4,a4
	move.w	(a4),d0
	cmp.w	a6,d0
	bne	chain_end
	moveq.l	#5,d6
chain:
	andi.w	#$7fff,(a4)
	tst.w	d3		*length = 1
	bne	@f

	PicBitWrite1ON
@@
	cmpi.b	#3,d6
	bgt	@f

	moveq.l	#2,d2
	move.l	d6,d3
	moveq.l	#30,d0
	asl.l	d0,d3
	PicBitWrite
@@
	cmpi.b	#4,d6
	bne	@f

	moveq.l	#4,d2
	move.l	#536870912,d3
	PicBitWrite
@@
	cmpi.b	#5,d6
	bne	@f

	moveq.l	#4,d2
	move.l	#805306368,d3
	PicBitWrite
@@
	moveq.l	#1,d3
	addq.w	#1,d5
cc_ylp_ent:
	cmp.w	_Height+2,d5
	blt	cc_ylp
chain_end:
	tst.w	d3
	bne	exist_chain

	PicBitWrite1OFF
	bra	quit_chain
exist_chain:
	moveq.l	#3,d2
	moveq.l	#0,d3
	PicBitWrite
quit_chain:
	movem.l	(sp)+,d4/d5/d6/a6

	sub.l	a3,a3
notmark:
	addq.w	#1,d4
c_xlp_ent:
	cmp.w	d6,d4
	blt	c_xlp

	addq.w	#1,d5
c_ylp_ent:
	cmp.w	_Height+2,d5
	blt	c_ylp

	addq.w	#1,a3
	bsr	WriteLength

	bsr	PicBufferWriteFlush
	move.l	BITBUFFER(a5),-(sp)
	DOS	_di_mfree
	addq.w	#4,sp
	move.w	FILEHANDLE(a5),d0
	cmpi.w	#1,d0
	beq	@f
	move.w	d0,-(sp)
	DOS	_di_close
	addq.w	#2,sp
@@
	movem.l	(sp)+,d3/d4/d5/d6/d7/a3/a4/a5/a6
	rts

?C6:
	.dc.b '%s: %s: Error in writing',$0a,$00

	.even
PicWriteBufferNext:
	subq.l	#2,BITBUFFERLENGTH(a5)
	bne	nextbyte
	move.l	#32768,d1
	move.l	d1,-(sp)
	move.l	BITBUFFER(a5),-(sp)
	move.w	FILEHANDLE(a5),-(sp)
	DOS	_di_write
	lea.l	10(sp),sp
	cmp.l	d1,d0
	beq	writeok
	lea.l	?C6(OPC),a0
	bra	errput
writeok:
	move.l	BITBUFFER(a5),BITBUFFERPOINTER(a5)
	move.l	d1,BITBUFFERLENGTH(a5)
	bra	bitinit
nextbyte:
	addq.l	#2,BITBUFFERPOINTER(a5)
bitinit:
	moveq.l	#16,d7
	rts

	.even
WriteLength:
	suba.l	a2,a2		*a
	moveq.l	#4,d3		*b
	move.l	a3,d0
	addq.l	#2,d0		*Length + 2
	bra	l_ent
l_lp:
	add.l	d3,d3
l_ent:
	addq.w	#1,a2
	cmp.l	d0,d3
	bcs	l_lp

	move.l	d3,a1
	move.l	a2,d2
	moveq.l #32,d0
	sub.w	a2,d0
	moveq.l	#-2,d3
	asl.l	d0,d3
	PicBitWrite

	move.l	a2,d2
	move.l	a1,d0
	lsr.l	#1,d0
	subq.l	#1,d0
	move.l	a3,d3
	sub.l	d0,d3
	moveq.l	#32,d0
	sub.w	d2,d0
	asl.l	d0,d3
	PicBitWrite
	rts

	.even
PicBufferWriteFlush:
	move.l	d7,d4
	cmpi.w	#16,d7
	beq	empty
	move.l	BITBUFFERPOINTER(a5),a0
	move.w	(a0),d0
	lsl.l	d7,d0
	move.w	d0,(a0)
	bsr	PicWriteBufferNext
empty:
	move.l	#32768,d2
	sub.l	BITBUFFERLENGTH(a5),d2
	andi.w	#15,d4
	beq	@f
	cmpi.w	#8,d4
	blt	@f
	subq.l	#1,d2
@@
	tst.l	d2
	bgt	@f
	rts
@@
	move.l	d2,-(sp)
	move.l	BITBUFFER(a5),-(sp)
	move.w	FILEHANDLE(a5),-(sp)
	DOS	_di_write
	lea.l	10(sp),sp
	cmp.l	d2,d0
	bne	@f
	rts
@@
	lea.l	?C6(OPC),a0
errput:
	move.l	a0,-(sp)
	jsr	_error
	addq.w	#4,sp
	rts

squarecomment:
	.dc.b	"/MM/XSS/:",0

	.even
WritePicHeader:
	movea.l	BITBUFFERPOINTER(a5),a0
	move.b	#'P',(a0)+
	move.b	#'I',(a0)+
	move.b	#'C',(a0)+
	tst.l	_NoExpand
	beq	@f
	lea.l	squarecomment(OPC),a1
cpylp:
	move.b	(a1)+,d0
	beq	@f
	move.b	d0,(a0)+
	bra	cpylp
@@
	move.b	#$1A,(a0)+
	clr.b	(a0)+
	clr.b	(a0)+
	clr.b	(a0)+
	clr.b	(a0)+
	move.b	#15,(a0)+

	move.l	_Width,d1
	move.l	d1,d0
	asr.l	#8,d1
	move.b	d1,(a0)+
	move.b	d0,(a0)+
	move.l	_Height,d1
	move.l	d1,d0
	lsr.w	#8,d1
	move.b	d1,(a0)+
	move.b	d0,(a0)+

	move.l	a0,d0
	moveq.l	#1,d1
	and.b	d0,d1
	beq	@f
	subq.l	#1,d0
	moveq.l	#8,d7
@@
	move.l	d0,BITBUFFERPOINTER(a5)
	sub.l	BITBUFFER(a5),d0
	sub.l	d0,BITBUFFERLENGTH(a5)
	rts

	.even
	.bss

BitBuf:
	.ds.b	14+4+2+512

	.xdef _PicWord
	.comm _PicWord,4
	.xdef _NoExpand
	.comm _NoExpand,4
	.xdef _BitBufferPointer
	.comm _BitBufferPointer,4

	.even
	.end
