* 4/3 transformation
* (width and height must be under 65535 pixels)

RUNS_HUMAN_VERSION	equ	3
	.cpu 68000
	.even

	.text
	.even

	.globl _Transform_ft
_Transform_ft:
	move.l	4(sp),d0	*OldWidth
	link	a6,#-96
	movem.l	d3-d7/a3,-(sp)

	lea.l	-96(a6),a0
	clr.w	(a0)+
	moveq.l	#31-1,d1
	moveq.l	#1,d2

tblinitlp:
	move.b	d2,(a0)+
	move.b	d2,(a0)+
	move.b	d2,(a0)+
	addq.w	#1,d2
	dbra	d1,tblinitlp
	move.b	d2,(a0)

	movea.l	_Screen,a2
	move.l	_Height,d1
	mulu	d1,d0
	add.l	d0,d0
	lea.l	(a2,d0.l),a1	*read

	adda.l	_Size,a2	*write

	movea.l	_Width,a3
	movea.l	d1,a0
	bra	ylp_ent

ylp:
	move.l	a3,d0

xlp:
	subq.w	#1,d0		*x--
	blt	ylp_ent

	move.w	-(a1),d3	*c1= *--read
	move.w	d3,-(a2)	*--write= c1

	subq.w	#1,d0		*x--
	blt	ylp_ent

	move.w	d3,d2
	lsr.w	#5,d2
	move.w	d2,d1
	lsr.w	#5,d1		*g1

	moveq.l	#31,d6
	and.w	d6,d2		*r1

	and.w	d6,d3		*b1

	move.w	-(a1),d7	*c2= *--read

	move.w	d7,d5
	lsr.w	#5,d5
	move.w	d5,d4
	lsr.w	#5,d4
	add.b	d4,d4		*g2

	and.w	d6,d5
	add.b	d5,d5		*r2

	and.w	d7,d6
	add.b	d6,d6		*b2

	moveq.l	#3,d7
	ext.l	d1		*g1
	add.b	d4,d1		*g1 + g2
	move.b	-96(a6,d1.l),d1		*g3

	ext.l	d2		*r1
	add.b	d5,d2		*r1 + r2
	move.b	-96(a6,d2.l),d2		*r3

	ext.l	d3		*b1
	add.b	d6,d3		*b1 + b2
	move.b	-96(a6,d3.l),d3		*b3

	lsl.w	#5,d1		*g3 << 5
	or.b	d2,d1		*r3
	lsl.w	#5,d1
	or.b	d3,d1		*b3
	move.w	d1,-(a2)	*--write

	subq.w	#1,d0		*x--
	blt	ylp_ent

	move.w	-(a1),d7	*c1= *--read
	move.w	d7,d2
	lsr.w	#5,d2
	move.w	d2,d1
	lsr.w	#5,d1		*g1

	moveq.l	#31,d3
	and.w	d3,d2		*r1

	and.w	d7,d3		*b1

	ext.l	d1		*g1
	add.b	d4,d1		*g1 + g2
	moveq.l	#3,d4
	move.b	-96(a6,d1.l),d1		*g3

	ext.l	d2		*r1
	add.b	d5,d2		*r1 + r2
	move.b	-96(a6,d2.l),d2		*r3

	add.b	d6,d3		*b1 + b2
	move.b	-96(a6,d3.l),d3		*b3

	lsl.w	#5,d1		*g3 << 5
	or.b	d2,d1		*r3
	lsl.w	#5,d1
	or.b	d3,d1		*b3
	move.w	d1,-(a2)	*write

	subq.w	#1,d0		*x--
	blt	ylp_ent

	move.w	d7,-(a2)	*--write= c1
	bra	xlp

ylp_ent:
	subq.l	#1,a0
	cmp.l	#0,a0
	bge	ylp

	movem.l	(sp)+,d3-d7/a3
	unlk	a6
	rts

	.even
	.end
