*3/4 transformation
*(width and height must be under 65536 pixels)

RUNS_HUMAN_VERSION	equ	3
	.cpu 68000
	.even

	.text
	.even

	.globl	_Transform_tf
_Transform_tf:
	movem.l d3-d7/a3-a4,-(sp)
	move.l	_Height,d7
	move.l	_Width,a4
	move.l	_Screen,a0	*read
	movea.l	a0,a1		*write= read
	move.l	#%1111101111011111_1111001110011111,a3
	bra	tf_ylpent

tf_ylp:
	move.l	a3,d4
	move.l	a4,d6		*Width

tf_xlp:
	subq.w	#1,d6
	bmi	tf_ylpent

	moveq.l	#0,d0
	move.w	(a0)+,d0	*pixel0

	subq.w	#1,d6
	bmi	tf_ylpent

	moveq.l	#0,d1
	move.w	(a0)+,d1	*pixel1

*	lsr.w	#1,d0		*pixel0
*	lsr.w	#1,d1		*pixel1
	move.l	d1,a2

	move.l	d0,d2		*pixel0
	move.l	d1,d3		*pixel1
	and.w	d4,d0
	and.w	d4,d1

	move.l	d0,d5		*pixel0
	add.w	d0,d0
	add.w	d5,d1
	add.l	d1,d0		*d0 * 3 + d1

	not.w	d4
	and.w	d4,d2
	and.w	d4,d3

	move.l	d2,d5
	add.w	d2,d2
	add.w	d5,d3
	add.l	d3,d2
	not.w	d4
	and.w	d4,d2

	add.l	d2,d0
	lsr.l	#2,d0
*	add.w	d0,d0

	move.w	d0,(a1)+	*new0

	subq.w	#1,d6
	bmi	tf_ylpent

	move.l	a2,d1
	moveq.l	#0,d0
	move.w	(a0)+,d0	*pixel2

*	lsr.w	#1,d0
	move.l	d0,d5
	swap.w	d4

	move.w	d0,d2
	move.w	d1,d3
	and.w	d4,d0
	and.w	d4,d1
	add.w	d1,d0
	not.w	d4
	and.w	d4,d2
	and.w	d4,d3
	add.w	d3,d2
	not.w	d4
	and.w	d4,d2
	add.w	d2,d0

	lsr.w	#1,d0
*	and.w	#$fffe,d0

	move.w	d0,(a1)+

	subq.w	#1,d6
	bmi	tf_ylpent

	move.w	(a0)+,d0	*pixel3

*	lsr.w	#1,d0
	move.l	d5,d1
	swap.w	d4
	move.l	d0,d2
	move.l	d1,d3
	and.w	d4,d0
	and.w	d4,d1
	move.l	d0,d5
	add.w	d0,d0
	add.w	d5,d1
	add.l	d1,d0
	not.w	d4
	and.w	d4,d2
	and.w	d4,d3
	move.l	d2,d5
	add.w	d2,d2
	add.w	d5,d3
	add.l	d3,d2
	not.w	d4
	and.w	d4,d2
	add.l	d2,d0
	lsr.l	#2,d0
*	add.w	d0,d0


	move.w	d0,(a1)+
	bra	tf_xlp

tf_ylpent:
	dbra	d7,tf_ylp

	movem.l (sp)+,d3-d7/a3-a4
	rts

	.even
	.end
